//+------------------------------------------------------------------+
//|                                                   Deviations.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

#define MODE_Average           0
#define MODE_Variance          1
#define MODE_AverageDeviation  2
#define MODE_StandardDeviation 3
#define MODE_Skewness          4
#define MODE_Kurtosis          5

   extern int price  = PRICE_CLOSE;
   extern int period = 14;
   extern int mode   = MODE_Average;

//
//
//
//
//

double buffer[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(2);
   SetIndexBuffer(0,buffer); SetIndexDrawBegin(0,period);
   SetIndexBuffer(1,prices);
   
   //
   //
   //
   //
   //
   
   mode = MathMax(MathMin(mode,5),0);
   string shortName="";
   string PriceType="";
   
      //
      //
      //
      //
      //
      
      switch(price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;
         case PRICE_OPEN:     PriceType = "Open";     break;
         case PRICE_HIGH:     PriceType = "High";     break;
         case PRICE_LOW:      PriceType = "Low";      break;
         case PRICE_MEDIAN:   PriceType = "Median";   break;
         case PRICE_TYPICAL:  PriceType = "Typical";  break;
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;
      }
   
      //
      //
      //
      //
      //
      
      switch (mode)
      {
         case MODE_Average:           shortName = "Average";            break;
         case MODE_AverageDeviation:  shortName = "Average deviation";  break;
         case MODE_StandardDeviation: shortName = "Standard deviation"; break;
         case MODE_Variance:          shortName = "Variance";           break;
         case MODE_Skewness:          shortName = "Skewness";           break;
         case MODE_Kurtosis:          shortName = "Kurtosis";           break;
      }
      
   //
   //
   //
   //
   //
         
   IndicatorShortName(shortName+" ("+period+","+PriceType+")");
   return(0);
}
int deinit(){ return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    countedBars = IndicatorCounted();
   int    i,limit;

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = Bars-countedBars;
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >=0; i--)
   {
      prices[i] = iMA(NULL,0,1,0,MODE_SMA,price,i);
      buffer[i] = iCalc(prices,period,mode,i);
   }
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iCalc(double &array[], double cPeriod,int cMode, int i)
{
   double average=0;
      for (int k=0; k<cPeriod; k++)     average += array[i+k];
                                        average /= cPeriod;
      if (cMode == MODE_Average) return(average);
      
   //
   //
   //
   //
   //
 
   double adeviation = 0;
   double deviation  = 0;
   double variance   = 0;
   double skewness   = 0;
   double kurtosis   = 0;
   double sumDiff    = 0;
     
      for (k=0; k<cPeriod; k++)
      {
         double d = array[i+k]-average;

         //
         //
         //
         //
         //
         
            adeviation += MathAbs(d);
            sumDiff    += d;
            variance   += d*d;
            skewness   += d*d*d;
            kurtosis   += d*d*d*d;
      }

   //
   //
   //
   //
   //
         
   adeviation  = adeviation/cPeriod;   
   variance    = (variance*cPeriod-sumDiff*sumDiff)/(cPeriod*(cPeriod-1.0));
   deviation   = MathSqrt(variance);
   if (variance != 0)
   {
      skewness = skewness/(cPeriod*variance*deviation);
      kurtosis = kurtosis/(cPeriod*variance*variance)-3.0;
   }
   else
   {
      skewness = 0;
      kurtosis = 0;
   }

   //
   //
   //
   //
   //
   
   switch (cMode)
   {
      case MODE_AverageDeviation:  return(adeviation);
      case MODE_StandardDeviation: return(deviation);
      case MODE_Variance:          return(variance);
      case MODE_Skewness:          return(skewness);
      case MODE_Kurtosis:          return(kurtosis);
   }
}